'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _swiper = require('swiper');

var _swiper2 = _interopRequireDefault(_swiper);

var _lodash = require('lodash.pickby');

var _lodash2 = _interopRequireDefault(_lodash);

var _swiperPropTypes = require('./swiperPropTypes');

var _swiperPropTypes2 = _interopRequireDefault(_swiperPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultSwiperProps = new _swiper2.default().params;

var ReactSwiper = function (_React$Component) {
  _inherits(ReactSwiper, _React$Component);

  function ReactSwiper() {
    _classCallCheck(this, ReactSwiper);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ReactSwiper).apply(this, arguments));
  }

  _createClass(ReactSwiper, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.drawSwiper();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.drawSwiper();
    }
  }, {
    key: 'drawSwiper',
    value: function drawSwiper() {
      if (this.swiper) {
        this.swiper.destroy(true, true);
      }

      var options = (0, _lodash2.default)(this.props, function (val) {
        return val !== undefined;
      });
      this.swiper = new _swiper2.default(this.swiperContainer, options);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        {
          className: this.props.containerClass,
          ref: function ref(el) {
            _this2.swiperContainer = el;
          }
        },
        _react2.default.createElement(
          'div',
          { className: this.props.wrapperClass },
          this.props.children.map(function (child, idx) {
            return _react2.default.createElement(
              'div',
              { key: child.key || idx, className: _this2.props.slideClass },
              child
            );
          })
        )
      );
    }
  }]);

  return ReactSwiper;
}(_react2.default.Component);

ReactSwiper.propTypes = _extends({}, _swiperPropTypes2.default, {
  children: _propTypes2.default.any.isRequired
});
ReactSwiper.defaultProps = _extends({}, defaultSwiperProps, {
  containerClass: 'swiper-container'
});
exports.default = ReactSwiper;